package com.gic.haoban.manage.service.service.chat.impl;

import java.util.Date;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.UniqueIdUtils;
import com.gic.haoban.manage.api.dto.StaffClerkRelationDTO;
import com.gic.haoban.manage.api.dto.chat.GroupChatPlanOwnerLogDTO;
import com.gic.haoban.manage.service.dao.mapper.chat.GroupChatPlanOwnerLogMapper;
import com.gic.haoban.manage.service.entity.TabHaobanClerkMainStoreRelated;
import com.gic.haoban.manage.service.entity.chat.TabGroupChatPlanOwnerLog;
import com.gic.haoban.manage.service.service.ClerkMainStoreRelatedService;
import com.gic.haoban.manage.service.service.StaffClerkRelationService;
import com.gic.haoban.manage.service.service.chat.GroupChatPlanOwnerLogService;

@Service("groupChatPlanOwnerLogService")
public class GroupChatPlanOwnerLogServiceImpl implements GroupChatPlanOwnerLogService {

    private static final Logger logger = LogManager.getLogger(GroupChatPlanOwnerLogService.class);

    @Autowired
    private GroupChatPlanOwnerLogMapper groupChatPlanOwnerLogMapper;
    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;

    
    public TabGroupChatPlanOwnerLog getById(Long ownerLogId){
        TabGroupChatPlanOwnerLog log = this.groupChatPlanOwnerLogMapper.selectById(ownerLogId) ;
        return log ;
    }
    
    @Override
    public void updateSendCount(Long id, int sendCount, Date sendTime) {
        this.groupChatPlanOwnerLogMapper.updateSendCount(id,sendCount,sendTime);
    }
    
    @Override
    public void save(GroupChatPlanOwnerLogDTO dto) {
        TabGroupChatPlanOwnerLog log = EntityUtil.changeEntityByJSON(TabGroupChatPlanOwnerLog.class, dto);
        log.setOwnerLogId(UniqueIdUtils.uniqueLong());
        log.setSendStatus(0);
        log.setCreateTime(new Date());
        log.setUpdateTime(new Date());
        log.setSendCount(0);
        String staffId = dto.getStaffId();

        TabHaobanClerkMainStoreRelated mainStore = this.clerkMainStoreRelatedService.getMainStoreByStaffId(staffId,
                dto.getWxEnterpriseId());
        if (null == mainStore) {
            log.setRemark("区经/未配置主门店");
        } else {
            StaffClerkRelationDTO clerk = this.staffClerkRelationService.getOneBindByStoreId(staffId,
                    mainStore.getStoreId());
            if (null != clerk) {
                log.setClerkId(clerk.getClerkId());
                log.setStoreId(mainStore.getStoreId());
            } else {
                log.setRemark("关联导购数据查不到");
                logger.info("导购关联数据不存在,staffid={},storeid={}", staffId, mainStore.getStoreId());
            }
        }
        this.groupChatPlanOwnerLogMapper.insert(log);
    }

}